;; marirc - command 3.1
;; By matt@liek.net
;; irc- irc.semicolon-zero.com #liek

;; Use 3 hash tables. ccmds Stores commands,
;; cgroups stores groups of commands,
;; cindex stores the placements of commands.

;; Allow only 1 layer of recursive command calls.


;; /ceco - Alias used to echo script messages ($1- - text)
alias -l ceco {
  echo -a 4[Cmd]: $1-
}

;; /c - Execute command ($1- - command(s))
alias c {
  lcdb
  var %i = 1
  var %cmd.end = $numtok($1-,32)
  while (%i <= %cmd.end) {
    c_help $gettok($1-,%i,32)
    inc %i 1
  }
}

;; /c_help - Internal execute command ($1 - command(s))
alias -l /c_help {
  var %cmdtype = $_checkce($1)
  if (%cmdtype == ccmd) {
    var %cmdstr = $hget(ccmds,$1)
    ceco Running command $1 ( $+ %cmdstr $+ )
    .run %cmdstr
  }
  elseif (%cmdtype == cgroups) {
    var %y = 1
    var %cmdstr = $hget(cgroups,$1)
    var %g.end = $numtok(%cmdstr,44)
    while (%y <= %g.end) {
      var %getcmd = $gettok(%cmdstr,%y,44)
      var %getcmdline = $hget(ccmds,%getcmd)
      ceco Running command %getcmd ( $+ %getcmdline $+ )
      .run %getcmdline
      inc %y 1
    }
  }
  else {
    ceco /c - Bad command ( $+ $1 $+ )
  }
}

;; /cadd - Add command ([switch], cmdname, code)
alias cadd {
  lcdb
  var %cmd.chk = $_checkswitches($1)
  if (%cmd.chk == badswitch) {
    ceco /cadd - Bad switch ( $+ $1 $+ )
    goto end
  }
  if (%cmd.chk == noswitch) {
    ;; Assume Regular command
    var %cmd.ce = $_checkce($1)
    ;echo -a %cmd.ce
    if (%cmd.ce == nocmd) {
      hdo ccmds $1 $2-
      hdo cindex $1 ccmd
      ceco Added command $1 ( $+ $2- $+ )
    }
    elseif (%cmd.ce == ccmd) {
      hdo ccmds $1 $2-
      hdo cindex $1 ccmd     
      ceco Updated command $1 ( $+ $2- $+ )
    }
    elseif (%cmd.ce == cgroups) {
      hdl cgroups $1
      ceco Replacing Group $1 with Command
      hdo cindex $1 ccmd
      hdo ccmds $1 $2-
      ceco Added command $1 ( $+ $2- $+ ) 
    }
    else {
      ceco /cadd - Error Unregonized return from type check
      goto end
    }
  }
  elseif (%cmd.chk == group) {
    var %cmd.grptotal = $numtok($3,44)
    var %i = 1
    while (%i <= %cmd.grptotal) {
      var %a = $hget(cindex,$gettok($3,%i,44))
      ;echo -a $gettok($2,%i,44) - %a
      if ((%a == $null) || (%a == cgroups)) {
        ceco /cadd - Bad command in group
        goto end
      }
      inc %i 1
    }
    var %cmd.ce = $_checkce($2)
    if (%cmd.ce == nocmd) {
      hdo cgroups $2 $3
      hdo cindex $2 cgroups
      ceco Added group $2 ( $+ $3 $+ )
    }
    elseif (%cmd.ce == cgroups) {
      hdo cgroups $2 $3
      hdo cindex $2 cgroups     
      ceco Updated group $2 ( $+ $3 $+ )
    }
    elseif (%cmd.ce == ccmds) {
      cleangroups $2
      hdl ccmds $2
      ceco Replacing command $2 with group
      hdo cindex $2 cgroups
      hdo cgroups $2 $3
      ceco Added group $2 ( $+ $3 $+ )
    }
    else {
      ceco /cadd - Error Unregonized return from type check
      goto end
    }
  }
  :end
}
;; /cdel - Remove command (cmdname)
alias cdel {
  lcdb
  var %checktype = $_checkce($1)
  if (%checktype == ccmd) {
    hdl ccmds $1
    hdl cindex $1
    cleangroups $1
    ceco Deleted command $1
  }
  elseif (%checktype == cgroups) {
    hdl cgroups $1
    hdl cindex $1
    ceco Deleted group $1
  }
  else {
    ceco /cdel - Invalid command name $1
  }
}

;; /cren - Rename Command (cmdname, new command name)
alias cren {
  lcdb
  var %checktype = $_checkce($1)
  var %checknewtype = $_checkce($2)
  if (%checknewtype != nocmd) {
    ceco /cren - Command %checknewtype already exists!
    return
  }
  if (%checktype == ccmd) {
    hren ccmds $1 $2
    hren cindex $1 $2
    fixgroups $1 $2
    ceco Renamed command $1 to $2
  }
  elseif (%checktype == cgroups) {
    hren cgroups $1 $2
    hren cindex $1 $2
    ceco Renamed group $1 to $2
  }
  else {
    ceco /cren - Command $1 does not exist!
  }
}

;; /clist - List commands ()
alias clist {
  lcdb
  if ($1 == groups) {
    var %i = 1
    var %list.end = $hfind(cindex,cgroups,0).data
    while (%i <= %list.end) {
      var %cmdname = $hfind(cindex,cgroups,%i).data
      ceco %i $+ : %cmdname ( $+ $hget(cgroups,%cmdname) $+ )
      inc %i 1
    }
    ceco End of list
  }
  elseif (($1 == cmds) || ($1 == commands)) {
    var %i = 1
    var %list.end = $hfind(cindex,ccmd,0).data
    while (%i <= %list.end) {
      var %cmdname = $hfind(cindex,ccmd,%i).data
      ceco %i $+ : %cmdname ( $+ $hget(ccmds,%cmdname) $+ )
      inc %i 1
    }
    ceco End of list
  }
  else {
    ceco /clist - Bad type
  }
}

;; /lcdb - Checks/Loads command hash tables ()
alias lcdb {
  if ($hget(ccmds) != ccmds) {
    hld ccmds
  }
  if ($hget(cgroups) != cgroups) {
    hld cgroups
  }
  if ($hget(cindex) != cindex) {
    hld cindex
  }
}

;; $_checkswitches - Checks for a switch (possible switch)
alias -l _checkswitches {
  if ($left($1,1) == -) {
    if ($1 == -g) {
      return group
    }
    elseif ($1 == -h) {
      ceco /cadd Switches
      ceco -g = Add group
      eceo No switch assumes command
      halt
    }
    else {
      return badswitch
    }
  }
  else {
    return noswitch
  }
}
;; $_checkce - Checks if command exists (possible cmdname)
alias -l _checkce {
  var %ce = $hget(cindex,$1)
  if (%ce != $null) {
    return %ce
  }
  else {
    return nocmd
  }
}

;; /cleangroups - Cleans all groups removing any trace of a Command (Command)
alias -l cleangroups {
  var %i = 1
  var %cmd.cg = $hget(cgroups,0).data
  while (%i <= %cmd.cg) {
    var %groupline = $hget(cgroups,%i).data
    while ($istok(%groupline,$1,44) == $true) {
      %groupline = $remtok(%groupline,$1,1,44)
    }
    hdo cgroups $hget(cgroups,%i).item %groupline
    inc %i 1
  }
}

;; /fixgroups - Renames all entries in groups that match (Command, New name)
alias -l fixgroups {
  var %i = 1
  var %cmd.cg = $hget(cgroups,0).data
  while (%i <= %cmd.cg) {
    var %groupline = $hget(cgroups,%i).data
    while ($istok(%groupline,$1,44) == $true) {
      %groupline = $reptok(%groupline,$1,$2,1,44)
    }
    hdo cgroups $hget(cgroups,%i).item %groupline
    inc %i 1
  }
}
