;; mirc elitetalker.bas
;; (C)2002 matt@liek.net
;; irc.semicolon-zero.com #liek

;; $do_reverse(text) - reverses text
alias do_reverse {
  var %text = $1-
  var %s.len = $len(%text)
  %text = $replace(%text,$chr(32),$chr(160))
  var %i = 1
  while (%i <= %s.len) {
    var %a = $mid(%text,%s.len,1)
    %text = $insertchar(%text,%a,%i)
    %text = $left(%text,%s.len)       
    inc %i 1
  }
  %text = $replace(%text,$chr(160),$chr(32))  
  if ($isid) {
    return %text
  }
  else {  
    echo -a Reverse- %text
  }
}

;; /reverse - Reverses text and sends to active ($1- -text) 
alias reverse {
  msg $active $do_reverse($1-)
}
;; /reverseself - Reverses text and echo's to active ($1- -text)
alias reverseself {
  echo -a Reverse- $do_reverse($1-)
}

;; $insertchar - Inserts char to string ($1 - text, $2 - char to insert, $3 - position to insert to)
alias insertchar {
  var %t.moo = $1
  if ($3 > 1) {
    var %t.moo = $left(%t.moo,$calc($3 - 1)) $+ $2 $+ $right(%t.moo,$calc($len(%t.moo) - $3 + 1))
  }
  else {
    var %t.moo = $2 $+ %t.moo
  }
  return %t.moo
}

;; $do_rot13 Preform rot13 conversion ($1- - text)
alias do_rot13 {
  var %text = $1-
  var %s.len = $len(%text)
  var %newtxt  
  %text = $replace(%text,$chr(32),$chr(160))
  var %i = 1
  while (%i <= %s.len) {
    if ((($asc($mid(%text,%i,1)) >= 65) && ($asc($mid(%text,%i,1)) <= 77))) {
      var %y = $calc($asc($mid(%text,%i,1)) + 13)
      %newtxt = %newtxt $+ $chr(%y)
    }
    elseif ((($asc($mid(%text,%i,1)) >= 78) && ($asc($mid(%text,%i,1)) <= 90))) {
      var %y = $calc($asc($mid(%text,%i,1)) - 13)
      %newtxt = %newtxt $+ $chr(%y)
    }
    elseif ((($asc($mid(%text,%i,1)) >= 97) && ($asc($mid(%text,%i,1)) <= 109))) {
      var %y = $calc($asc($mid(%text,%i,1)) + 13)
      %newtxt = %newtxt $+ $chr(%y)
    }
    elseif ((($asc($mid(%text,%i,1)) >= 110) && ($asc($mid(%text,%i,1)) <= 122))) {
      var %y = $calc($asc($mid(%text,%i,1)) - 13)     
      %newtxt = %newtxt $+ $chr(%y)
    }
    else {
      %newtxt = %newtxt $+ $mid(%text,%i,1)
    }
    inc %i 1
  }
  %newtxt = $replace(%newtxt,$chr(160),$chr(32))
  if ($isid) {
    return %newtxt
  }
  else {
    echo -a ROT13- %newtxt
  }
}

;; /rot13 - Perform rot13 conversion and send to active ($1 - text)
alias rot13 {
  msg $active $do_rot13($1-)
}

;; /rot13self - Perform rot13 conversion and echo to active ($1 - text)
alias rot13self {
  echo -a ROT13- $do_rot13($1-)
}

;; /revrot13 - Preform reversed rot13 conversion and send to active ($1 - text)
alias revrot13 {
  msg $active $do_rot13($do_reverse($1-))
}

;; /revrot13self - Perform reversed rot13 conversion and send to active ($1 - text)
alias revrot13self {
  echo -a Reversed ROT13- $do_rot13($do_reverse($1-))
}
